package com.unipi.talepis.singletons;


import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class Demo {
    public static void main(String[] args) {
        /*SingletonV1 s1 = SingletonV1.getInstance();
        SingletonV1 s2 = SingletonV1.getInstance();
        System.out.println(s1.hashCode());
        System.out.println(s2.hashCode());

        SingletonV3 s3 = SingletonV3.getInstance();
        SingletonV3 s4 = SingletonV3.getInstance();
        System.out.println(s3.hashCode());
        System.out.println(s4.hashCode());*/

        attackToSingletonV2();
        attackToSingletonV2_3();
    }

    private static void attackToSingletonV2(){
        SingletonV2 s1 = SingletonV2.getInstance();
        SingletonV2 s2 = null;
        try {
            Constructor constructor = SingletonV2.class.getDeclaredConstructor();
            constructor.setAccessible(true);
            s2 = (SingletonV2) constructor.newInstance();
        } catch (NoSuchMethodException | InvocationTargetException | InstantiationException | IllegalAccessException e) {
            e.printStackTrace();
        }
        System.out.println("Attack started");
        System.out.println(s1.hashCode());
        System.out.println(s2.hashCode());
    }
    private static void attackToSingletonV2_3(){
        SingletonV2_3 s1 = SingletonV2_3.getInstance();
        SingletonV2_3 s2 = null;
        try {
            Constructor constructor = SingletonV2_3.class.getDeclaredConstructor();
            constructor.setAccessible(true);
            s2 = (SingletonV2_3) constructor.newInstance();
        } catch (NoSuchMethodException | InvocationTargetException | InstantiationException | IllegalAccessException e) {
            e.printStackTrace();
        }
        System.out.println("Attack started");
        System.out.println(s1.hashCode());
        System.out.println(s2.hashCode());
    }

}
